VSTGUI: CScrollView Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Types | List of all members
CScrollView Class Reference
Views » Container Views

a scrollable container view with scrollbars More...

`#include <cscrollview.h>`

Inheritance diagram for CScrollView:

## Public Types
enum | CScrollViewStyle { kHorizontalScrollbar = 1 << kHorizontalScrollbarFlag , kVerticalScrollbar = 1 << kVerticalScrollbarFlag , kDontDrawFrame = 1 << kDontDrawFrameFlag , kAutoDragScrolling = 1 << kAutoDragScollingFlag , kOverlayScrollbars = 1 << kOverlayScrollbarsFlag , kFollowFocusView = 1 << kFollowFocusViewFlag , kAutoHideScrollbars = 1 << kAutoHideScrollbarsFlag }
| Scroll View Style Flags. More...
Public Types inherited from CViewContainer
using | ViewList = std::list<SharedPointer<CView>>
using | ChildViewConstIterator = ViewList::const_iterator
using | ChildViewConstReverseIterator = ViewList::const_reverse_iterator
enum class | MouseListenerCall { MouseDown , MouseMoved , MouseUp , MouseCancel }

## Public Member Functions
| CScrollView (const CRect &size, const CRect &containerSize, int32_t style, CCoord scrollbarWidth=16, CBitmap *pBackground=nullptr)
Public Member Functions inherited from CViewContainer
| CViewContainer (const CRect &size)
| CViewContainer constructor.
| CViewContainer (const CViewContainer &viewContainer)
bool | addView (CView *pView, const CRect &mouseableArea, bool mouseEnabled=true)
| add a child view
bool | isChild (CView *pView) const
| check if pView is a child view of this container
virtual bool | isChild (CView *pView, bool deep) const
| check if pView is a child view of this container
virtual bool | hasChildren () const
| check if container has child views
virtual CView * | getViewAt (const CPoint &where, const GetViewOptions &options=GetViewOptions()) const
| get the view at point where
virtual CViewContainer * | getContainerAt (const CPoint &where, const GetViewOptions &options=GetViewOptions().deep()) const
| get the container at point where
virtual bool | getViewsAt (const CPoint &where, ViewList &views, const GetViewOptions &options=GetViewOptions().deep()) const
| get all views at point where, top->down
virtual bool | hitTestSubViews (const CPoint &where, const Event &event)
virtual void | setAutosizingEnabled (bool state)
| enable or disable autosizing subviews.
bool | getAutosizingEnabled () const
template<class ViewClass, class ContainerClass>
uint32_t | getChildViewsOfType (ContainerClass &result, bool deep=false) const
| get child views of type ViewClass.
template<typename Proc>
void | forEachChild (Proc proc) const
| execute proc for each child view
template<typename Proc>
CView * | findFirstViewIf (Proc filter) const
void | setViewLayouter (const SharedPointer< IViewLayouter > &layouter)
| set a view layouter
SharedPointer< IViewLayouter > | getViewLayouter () const
| get the current view layouter
std::optional< ViewLayout > | calculateViewLayout (const CRect &newSize) const
| calculate the view layout for the new size
bool | applyViewLayout (const ViewLayout &layout)
| apply a previously calculated view layout
bool | inApplyViewLayout () const
| check if a view layout is currently applied
virtual CColor | getBackgroundColor () const
| get the background color
virtual void | setBackgroundOffset (const CPoint &p)
| set the offset of the background bitmap
virtual CPoint | getBackgroundOffset () const
| get the offset of the background bitmap
virtual void | setBackgroundColorDrawStyle (CDrawStyle style)
CDrawStyle | getBackgroundColorDrawStyle () const
void | setInitialFocusView (CView *view)
| set custom initial focus view which is first focused when advanceNextFocusView is called without oldFocus view
CView * | getInitialFocusView () const
| get custom initial focus view
virtual bool | advanceNextFocusView (CView *oldFocus, bool reverse=false)
virtual bool | invalidateDirtyViews ()
virtual CRect | getVisibleSize (const CRect &rect) const
void | setTransform (const CGraphicsTransform &t)
const CGraphicsTransform & | getTransform () const
void | registerViewContainerListener (IViewContainerListener *listener)
void | unregisterViewContainerListener (IViewContainerListener *listener)
void | draw (CDrawContext *pContext) override
void | drawRect (CDrawContext *pContext, const CRect &updateRect) override
void | onMouseDownEvent (MouseDownEvent &event) override
| called when a mouse down event occurs
void | onMouseMoveEvent (MouseMoveEvent &event) override
| called when a mouse move event occurs
void | onMouseUpEvent (MouseUpEvent &event) override
| called when a mouse up event occurs
void | onMouseCancelEvent (MouseCancelEvent &event) override
| called when mouse tracking should be canceled
void | onMouseWheelEvent (MouseWheelEvent &event) override
| called when a mouse wheel event occurs
void | onZoomGestureEvent (ZoomGestureEvent &event) override
| called when a zoom gesture event occurs
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) final
SharedPointer< IDropTarget > | getDropTarget () override
| get the drag target for drag and drop handling
void | looseFocus () override
| called if view should loose focus
void | takeFocus () override
| called if view should take focus
bool | isDirty () const override
| check if view is dirty
void | invalid () override
| mark whole view as invalid
void | invalidRect (const CRect &rect) override
| mark rect as invalid
void | setViewSize (const CRect &rect, bool invalid=true) override
void | parentSizeChanged () override
| notification that one of the views parent has changed its size
bool | sizeToFit () override
| resize view to optimal size
bool | removed (CView *parent) override
| view is removed from parent view
bool | attached (CView *parent) override
| view is attached to a parent view
CPoint & | frameToLocal (CPoint &point) const override
| conversion from frame coordinates to local view coordinates
CPoint & | localToFrame (CPoint &point) const override
| conversion from local view coordinates to frame coordinates
CBaseObject * | newCopy () const override
CViewContainer * | asViewContainer () final
const CViewContainer * | asViewContainer () const final
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
uint64_t | getRuntimeID () const
| get the unique runtime ID
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons)
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
int32_t | getAutosizeFlags () const
| get autosize flags
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T>
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T>
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
bool | isAttached () const
| is view attached to a parentView
void | setSubviewState (bool state)
bool | isSubview () const
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T>
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T>
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CBaseObject * | newCopy () const override
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle.
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexcept override=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
Public Member Functions inherited from ReferenceCounted< int32_t >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
| ReferenceCounted ()=default
| ReferenceCounted (const ReferenceCounted &)
virtual | ~ReferenceCounted () noexcept=default
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IControlListener
virtual | ~IControlListener () noexcept=default
virtual int32_t | controlModifierClicked (CControl *pControl, CButtonState button)
| return 1 if you want the control to not handle it, otherwise 0
virtual void | controlBeginEdit (CControl *pControl)
virtual void | controlEndEdit (CControl *pControl)
virtual void | controlTagWillChange (CControl *pControl)
virtual void | controlTagDidChange (CControl *pControl)
Public Member Functions inherited from ViewListenerAdapter
void | viewSizeChanged (CView *view, const CRect &oldSize) override
| called when the view's size changed
void | viewAttached (CView *view) override
| called when a view was attached to a view hierarchy
void | viewRemoved (CView *view) override
| called when a view was removed from the view hierarchy
void | viewLostFocus (CView *view) override
| called when a view lost focus
void | viewTookFocus (CView *view) override
| called when a view took focus
void | viewWillDelete (CView *view) override
| called when a view is going to be destroyed
void | viewOnMouseEnabled (CView *view, bool state) override
| called when a view's mouse handling is enabled or disabled
Public Member Functions inherited from IViewListener
virtual | ~IViewListener () noexcept=default

## Protected Types
enum | { kHorizontalScrollbarFlag , kVerticalScrollbarFlag , kDontDrawFrameFlag , kAutoDragScollingFlag , kOverlayScrollbarsFlag , kFollowFocusViewFlag , kAutoHideScrollbarsFlag , kLastScrollViewStyleFlag }
Protected Types inherited from CViewContainer
enum | { kAutosizeSubviews = 1 << (CView::kLastCViewFlag + 1) , kInApplyLayout = 1 << (CView::kLastCViewFlag + 2) }
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0 , kTransparencyEnabled = 1 << 1 , kWantsFocus = 1 << 2 , kIsAttached = 1 << 3 , kVisible = 1 << 4 , kDirty = 1 << 5 , kWantsIdle = 1 << 6 , kIsSubview = 1 << 7 , kHasAlpha = 1 << 8 , kHasBackground = 1 << 9 , kHasDisabledBackground = 1 << 10 , kHasMouseableArea = 1 << 11 , kLastCViewFlag = 11 }

## CScrollView Methods
enum class | Edge { Top , Left }
static constexpr int32_t | kHSBTag = 0
static constexpr int32_t | kVSBTag = 1
int32_t | getStyle () const
void | setStyle (int32_t newStyle)
int32_t | getActiveScrollbars () const
CCoord | getScrollbarWidth () const
void | setScrollbarWidth (CCoord width)
virtual void | setContainerSize (const CRect &cs, bool keepVisibleArea=false)
| set the virtual size of this container
const CRect & | getContainerSize () const
const CPoint & | getScrollOffset () const
| get scroll offset
void | setScrollOffset (CPoint newOffset)
| set scroll offset
void | resetScrollOffset ()
CScrollbar * | getVerticalScrollbar () const
| get the vertical scrollbar
CScrollbar * | getHorizontalScrollbar () const
| get the horizontal scrollbar
virtual void | makeRectVisible (const CRect &rect)
| set scrollview to show rect
CRect | calculateOptimalContainerSize () const
| calculate the maximum rect where the scrollbars are inactive
CRect | getVisibleClientRect () const
| returns the visible rect of the client
void | setEdgeView (Edge edge, CView *view)
| set a static edge view
CView * | getEdgeView (Edge edge) const
bool | attached (CView *parent) override
| view is attached to a parent view
bool | addView (CView *pView, CView *pBefore=nullptr) override
| add a child view before another view
bool | removeView (CView *pView, bool withForget=true) override
| remove a child view
bool | removeAll (bool withForget=true) override
| remove all child views
uint32_t | getNbViews () const override
| get the number of child views
CView * | getView (uint32_t index) const override
| get the child view at index
bool | changeViewZOrder (CView *view, uint32_t newIndex) override
| change view z order position
void | drawBackgroundRect (CDrawContext *pContext, const CRect &_updateRect) override
| draw the background
void | onMouseWheelEvent (MouseWheelEvent &event) override
| called when a mouse wheel event occurs
void | valueChanged (CControl *pControl) override
void | setTransparency (bool val) override
| set views transparent state
void | setBackgroundColor (const CColor &color) override
| set the background color (will only be drawn if this container is not set to transparent and does not have a background bitmap)
void | setViewSize (const CRect &rect, bool invalid=true) override
| set views size
void | setAutosizeFlags (int32_t flags) override
| set autosize flags
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
CBaseObject * | newCopy () const override
| ~CScrollView () noexcept override
void | recalculateLayout ()
void | preLayouting () const
void | syncScrollbars (bool keepVisibleArea)
void | syncHScrollbar (bool keepVisibleArea)
void | syncVScrollbar (bool keepVisibleArea)
void | viewSizeChanged (CView *view, const CRect &oldSize) override
| called when the view's size changed
void | viewWillDelete (CView *view) override
| called when a view is going to be destroyed
CScrollContainer * | getScrollContainer () const

## Additional Inherited Members
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle.
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz
| ~CViewContainer () noexcept override
void | beforeDelete () override
virtual bool | checkUpdateRect (CView *view, const CRect &rect)
| check if view needs to be updated for rect
void | setMouseDownView (CView *view)
CView * | getMouseDownView () const
const ViewList & | getChildren () const
| ~CView () noexcept override
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Detailed Description

a scrollable container view with scrollbars

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| protected

Enumerator
kHorizontalScrollbarFlag |
kVerticalScrollbarFlag |
kDontDrawFrameFlag |
kAutoDragScollingFlag |
kOverlayScrollbarsFlag |
kFollowFocusViewFlag |
kAutoHideScrollbarsFlag |
kLastScrollViewStyleFlag |

## ◆ CScrollViewStyle

enum CScrollViewStyle

Scroll View Style Flags.

Enumerator
kHorizontalScrollbar | add a horizontal scrollbar
kVerticalScrollbar | add a vertical scrollbar
kDontDrawFrame | don't draw frame
kAutoDragScrolling | automatic scrolling for drag moves
kOverlayScrollbars | scrollbars are overlayed of the content
kFollowFocusView | scroll to focus view when focus view changes
kAutoHideScrollbars | automatically hides the scrollbar if the container size is smaller than the size of the scrollview

## ◆ Edge

enum class Edge
| strong

Enumerator
Top |
Left |

## Constructor & Destructor Documentation

## ◆ CScrollView()

CScrollView | ( | const CRect & | size,
|  | const CRect & | containerSize,
|  | int32_t | style,
|  | CCoord | scrollbarWidth = 16,
|  | CBitmap * | pBackground = nullptr )

## ◆ ~CScrollView()

~CScrollView | ( |  | ) |
| overrideprotecteddefaultnoexcept

## Member Function Documentation

## ◆ addView()

bool addView | ( | CView * | pView,
|  | CView * | pBefore = nullptr )
| overridevirtual

add a child view before another view

Parameters

  pView | the view object to add to this container
  pBefore | the view object

Returns
  true on success. false if view was already attached

Reimplemented from CViewContainer.

## ◆ attached()

bool attached | ( | CView * | parent | ) |
| overridevirtual

view is attached to a parent view

Parameters

  parent | parent view

Returns
  true if view successfully attached to parent

Reimplemented from CView.

## ◆ calculateOptimalContainerSize()

CRect calculateOptimalContainerSize | ( |  | ) | const

calculate the maximum rect where the scrollbars are inactive

## ◆ changeViewZOrder()

bool changeViewZOrder | ( | CView * | view,
|  | uint32_t | newIndex )
| overridevirtual

change view z order position

Parameters

  view | view which z order position should be changed
  newIndex | index of new z position

Returns
  true if z order of view changed

Reimplemented from CViewContainer.

## ◆ drawBackgroundRect()

void drawBackgroundRect | ( | CDrawContext * | pContext,
|  | const CRect & | _updateRect )
| overridevirtual

draw the background

Parameters

  pContext | the context which to use to draw the background
  _updateRect | the area which to draw

Reimplemented from CViewContainer.

## ◆ getActiveScrollbars()

int32_t getActiveScrollbars | ( |  | ) | const

## ◆ getContainerSize()

const CRect & getContainerSize | ( |  | ) | const

## ◆ getEdgeView()

CView * getEdgeView | ( | Edge | edge | ) | const

## ◆ getHorizontalScrollbar()

CScrollbar * getHorizontalScrollbar | ( |  | ) | const

get the horizontal scrollbar

## ◆ getNbViews()

uint32_t getNbViews | ( |  | ) | const
| overridevirtual

get the number of child views

Returns
  number of subviews

Reimplemented from CViewContainer.

## ◆ getScrollbarWidth()

CCoord getScrollbarWidth | ( |  | ) | const

## ◆ getScrollContainer()

CScrollContainer * getScrollContainer | ( |  | ) | const
| protected

## ◆ getScrollOffset()

const CPoint & getScrollOffset | ( |  | ) | const

get scroll offset

## ◆ getStyle()

int32_t getStyle | ( |  | ) | const

## ◆ getVerticalScrollbar()

CScrollbar * getVerticalScrollbar | ( |  | ) | const

get the vertical scrollbar

## ◆ getView()

CView * getView | ( | uint32_t | index | ) | const
| overridevirtual

get the child view at index

Parameters

  index | the index of the view to return

Returns
  view at index. NULL if view at index does not exist.

Reimplemented from CViewContainer.

## ◆ getVisibleClientRect()

CRect getVisibleClientRect | ( |  | ) | const

returns the visible rect of the client

## ◆ makeRectVisible()

void makeRectVisible | ( | const CRect & | rect | ) |
| virtual

set scrollview to show rect

## ◆ newCopy()

CBaseObject * newCopy | ( |  | ) | const
| inlineoverride

## ◆ notify()

CMessageResult notify | ( | CBaseObject * | sender,
|  | IdStringPtr | message )
| overridevirtual

Reimplemented from CBaseObject.

## ◆ onMouseWheelEvent()

void onMouseWheelEvent | ( | MouseWheelEvent & | event | ) |
| overridevirtual

called when a mouse wheel event occurs

Reimplemented from CView.

## ◆ preLayouting()

void preLayouting | ( |  | ) | const
| protected

## ◆ recalculateLayout()

void recalculateLayout | ( |  | ) |
| protected

## ◆ removeAll()

bool removeAll | ( | bool | withForget = true | ) |
| overridevirtual

remove all child views

Parameters

  withForget | bool to indicate if the view's reference counter should be decreased after removed from the container

Returns
  true on success

Reimplemented from CViewContainer.

## ◆ removeView()

bool removeView | ( | CView * | pView,
|  | bool | withForget = true )
| overridevirtual

remove a child view

Parameters

  pView | the view which should be removed from the container
  withForget | bool to indicate if the view's reference counter should be decreased after removed from the container

Returns
  true on success

Reimplemented from CViewContainer.

## ◆ resetScrollOffset()

void resetScrollOffset | ( |  | ) |

## ◆ setAutosizeFlags()

void setAutosizeFlags | ( | int32_t | flags | ) |
| overridevirtual

set autosize flags

Reimplemented from CView.

## ◆ setBackgroundColor()

void setBackgroundColor | ( | const CColor & | color | ) |
| overridevirtual

set the background color (will only be drawn if this container is not set to transparent and does not have a background bitmap)

Parameters

  color | the new background color of the container

Reimplemented from CViewContainer.

## ◆ setContainerSize()

void setContainerSize | ( | const CRect & | cs,
|  | bool | keepVisibleArea = false )
| virtual

set the virtual size of this container

## ◆ setScrollbarWidth()

void setScrollbarWidth | ( | CCoord | width | ) |

## ◆ setScrollOffset()

void setScrollOffset | ( | CPoint | newOffset | ) |

set scroll offset

## ◆ setStyle()

void setStyle | ( | int32_t | newStyle | ) |

## ◆ setTransparency()

void setTransparency | ( | bool | val | ) |
| overridevirtual

set views transparent state

Reimplemented from CView.

## ◆ setViewSize()

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = true )
| overridevirtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented from CView.

## ◆ syncHScrollbar()

void syncHScrollbar | ( | bool | keepVisibleArea | ) |
| protected

## ◆ syncScrollbars()

void syncScrollbars | ( | bool | keepVisibleArea | ) |
| protected

## ◆ syncVScrollbar()

void syncVScrollbar | ( | bool | keepVisibleArea | ) |
| protected

## ◆ valueChanged()

void valueChanged | ( | CControl * | pControl | ) |
| overridevirtual

Implements IControlListener.

## ◆ viewSizeChanged()

void viewSizeChanged | ( | CView * | view,
|  | const CRect & | oldSize )
| overrideprotectedvirtual

called when the view's size changed

Implements IViewListener.

## ◆ viewWillDelete()

void viewWillDelete | ( | CView * | view | ) |
| overrideprotectedvirtual

called when a view is going to be destroyed

Implements IViewListener.

## Member Data Documentation

## ◆ kHSBTag

int32_t kHSBTag = 0
| staticconstexprprotected

## ◆ kVSBTag

int32_t kVSBTag = 1
| staticconstexprprotected

The documentation for this class was generated from the following files:

- cscrollview.h
- cscrollview.cpp